/*
 *  SMTPmail.java
 *  soh@napc.syr.edu
 *
 */


import java.util.*;
import java.net.*;
import java.io.*;
import netscape.security.PrivilegeManager;

public class SMTPmail {
  
  // global vars
  String smtp_host = "localhost" ;
  String from_name = "unknown";
  String from_adr = "unknown@localhost";
  String sender_name = "";
  String sender_adr = "";
  String s_subject = "";
  String auth_name = "Tango_mail";

  // all targets are Vectors
  Vector to_name = new Vector();            // To 
  Vector to_adr = new Vector();
  Vector reply_name = new Vector();         // Reply-To
  Vector reply_adr = new Vector(); 
  Vector cc_name = new Vector();            // CC
  Vector cc_adr = new Vector(); 

  
  // text
  StringBuffer s_any = new StringBuffer();
  
  // socket & others
  Socket s = null;
  PrintWriter pout;
  DataInputStream pin;
  
  // debug and verify
  boolean do_verify = true;
  boolean do_debug = false;
  int time_out = 20;                        //is time times 200 millies
 
 
  // initiate all variables
  private void create_all() {
    to_name.addElement("unknown");
    to_adr.addElement("root@localhost"); 
    reply_name.addElement("unknown"); 
    reply_adr.addElement("root@localhost");
    cc_name.addElement("unknown");
    cc_adr.addElement("root@localhost");
  }
  
  
  private StringBuffer read_line ( DataInputStream fin )
    throws IOException {    
        
        // read one line get File in Stream
        StringBuffer line = new StringBuffer(""); 
        char b;   
        
        while (fin.available() > 0) {
            b = (char) fin.read();
            if ( b == '\n' ) {
	            // one line read
	            break;
            }
            line.append(b);
        }
        return (line);
    }
  

  public SMTPmail(String host) {
    smtp_host = host;
    create_all();  		
  }
  
  
  public SMTPmail() {
    create_all();
  }
  
  
  public void setFrom (String real_name, String address) {
    from_name = real_name ;
    from_adr = address;
  }


  public void setVerify (boolean how) {
    do_verify = how ;
  }



  public void setDebug (boolean how) {
    do_debug = how ;
  }



  public void setTimeOut (int steps) {
    time_out = steps ;
  }


  public void addTo (String real_name, String address) {
    if ( ((String) to_name.elementAt(0)).compareTo("unknown") == 0 ) {
      // used first time - clean up array
      to_name.removeAllElements();
      to_adr.removeAllElements();
    }
    StringTokenizer to_token = new StringTokenizer(address,",");

    while(to_token.hasMoreTokens()) {
    to_adr.addElement(to_token.nextToken());
    to_name.addElement("") ;
    }    
  }


  public void addCc (String real_name, String address) {
    
    if ( ((String) cc_name.elementAt(0)).compareTo("unknown") == 0 ) {
      // used first time - clean up array
      cc_name.removeAllElements();
      cc_adr.removeAllElements();
    }
    
    StringTokenizer cc_token = new StringTokenizer(address,",");
    
    while(cc_token.hasMoreTokens()) {
    cc_adr.addElement(cc_token.nextToken());
    cc_name.addElement("") ;
    }    
  }


  public void addReplyTo (String real_name, String address) {   
    if ( ((String) reply_name.elementAt(0)).compareTo("unknown") == 0 )  {
      // used first time - clean up array
      reply_name.removeAllElements();
      reply_adr.removeAllElements();
    }
    reply_name.addElement(real_name) ;
    reply_adr.addElement(address);    
  }


  public void addAny (String complete_line) {
    s_any.append(complete_line + "\n");
  }
 
 
  public void setSubject( String subject ) {
    s_subject = subject ;
  }


  private String buildStandardField( String cleartext, String address) {    
    return (cleartext + " <" + address + "> ");
  }
  
  
  private void check_response (int respvalue) 
    throws SMTPException {
        // first, lets wait few ms to let the smtp daemon react
        String response = "";
        int counter = 0;
        while ( response.length() == 0 ) {
            try { Thread.sleep(200);
            } catch ( InterruptedException e1) {
            }
            
            try {
	            response = new String(read_line(pin));
            } catch ( IOException e ) {
	            throw (new SMTPException("IOException while reading from smtpd.: " + e.getMessage()));
            }
            
            counter += 1;
            if (counter > time_out) {
	            // stop it. theres somthing wrong
	            throw (new SMTPException("SMTPmail: Timeout while waiting for smtpd response."));	
            }
        }
        
        if (do_debug == true) { 
            System.out.println("-- SMTPmail Debug: Response: \n" + response );
        }
        
        // check return value
        int retval = 0;
        try {
            retval =   ((int)  Integer.parseInt( response.substring(0,3)) );
        } catch (Exception e) {
            retval = 0;
        }
        
        if ( retval == respvalue ) {
            if (do_debug == true) { 
	            System.out.println("-- SMTPmail Debug: Response Ok (" + retval + "). ");
        }
        } else {
            if (do_debug == true) { 
	            System.out.println("-- SMTPmail Debug: Response NOT Ok. (Should be " + 
			    response + " but is " + retval + 
			    "Troughd exception.");
            }
            throw (new SMTPException("Wrong smtpd response: Should be " + response + ", is " +
      	       retval ));
            }
    }
  

  private void send_out ( String msg, int respvalue ) throws SMTPException {
  
    // read and write channel are global
    pout.println(msg);	
    if (do_verify == true) {
        if (do_debug == true) { 
	        System.out.println("-- SMTPmail Debug: Sent: \n" + msg);    
        }
        check_response( respvalue );
    }
  }


  
  public void sendMail() throws SMTPException  {
    try {
      int i;
      try {  
          PrivilegeManager.enablePrivilege("UniversalConnect");
          s = new Socket(smtp_host,25);
      }
      catch (Exception e) {
        System.out.println("Exception " +e);
      }
      pout = new PrintWriter(s.getOutputStream(),true);
      pin = new DataInputStream(s.getInputStream());
      check_response(220);
      
      // SMTP
      send_out("HELO " + auth_name ,250);  
      send_out("MAIL FROM: <" + from_adr + ">", 250);
      
      // target adressees
      for ( i = 0; i < to_adr.size() ; i++) { //to
	    send_out("RCPT TO: <" + ((String) to_adr.elementAt(i)) + ">", 250);
      }
      
      if ( ((String) cc_name.elementAt(0)).compareTo("unknown") != 0 ) {
           for ( i = 0; i < cc_adr.size() ; i++) { //cc
	            send_out("RCPT TO: <" + ((String) cc_adr.elementAt(i)) + ">", 250);
	        }
      }
 
       
      // Data
      send_out("DATA", 354);
      if (do_debug == true) { 
	        System.out.println("-- SMTPmail Debug: Sending message body... ");
      }    
      
      // std Fields     
      pout.println("DATE: " + new Date(System.currentTimeMillis()));
      pout.println("From: " + buildStandardField(from_name, from_adr)); // from
      pout.println("Sender: " + buildStandardField(sender_name, sender_adr)); // Sender
      
      for ( i = 0; i < to_adr.size() ; i++) { //to
	    pout.println("To: " + buildStandardField(((String) to_name.elementAt(i)),
						((String) to_adr.elementAt(i)) ));
      }
      
      if ( ((String) reply_name.elementAt(0)).compareTo("unknown") == 0 )  { 
      }
      else{
         for ( i = 0; i < reply_adr.size() ; i++) {
	        pout.println("Reply-To: " + buildStandardField(((String) reply_name.elementAt(i)),
			    ((String) reply_adr.elementAt(i)) ));
	    }
	  }
      
      
      if ( ((String) cc_name.elementAt(0)).compareTo("unknown") == 0) { 
      }
      else{
         for ( i = 0; i < cc_adr.size() ; i++) {
	        pout.println("Cc: " + buildStandardField(((String) cc_name.elementAt(i)),
	  		    ((String) cc_adr.elementAt(i)) ));	  	
         }
      }
      
      pout.println("Subject: " + s_subject);
      
      // -- extraordinary data
      if ( s_any.length() > 0 ) {
	        pout.println(s_any);
      }
      pout.println("");
      
      
      // done
      pout.println(".");     
      check_response(250);
    } 
     
    catch (IOException e) {
      // through my own exception
        if ( do_debug == true) {
	        System.out.println("-- SMTPmail Debug: Error" + e.getMessage() + " throw exception." );
    }
      throw (new SMTPException("IOException collected: " + e.getMessage()));
    }
    
    
    try {
      // this has to be handles extra, because smtpd might be quick
      send_out("QUIT", 221);
      s.close();
    } catch (IOException e1) {
      // ignore it here
    }        
    
    if ( do_debug == true) {
      System.out.println("-- SMTPmail Debug: done.");
    }   
  }
}

