/*
 *  FILE : MailClient.java
 *  Ver  : 1.1      (July, `99)
 *  AUHTHOR : Sangyoon Oh
 *            soh@napc.syr.edu
 *  This MailClient class / Applet provide Client module of RMI
 *  ( This is for test/example of MailServer usage )
 *
 *
 *  Maintenance :
 *      ver 1.0 : created MailClient Applet Module
 *      ver 1.1 : minor change on parameter (smtphost)
 *  
 */

import java.awt.*;
import java.applet.*;
import java.io.*;
import java.lang.*;
import java.rmi.*;
import java.rmi.registry.*;
import java.util.*;
import netscape.security.PrivilegeManager;
import webwisdom.tango.newca.view.MailServer;

public class MailClient extends Applet
{
    // This is very necessary part 
    // from here

    // do declare MailServer
    //
    MailServer ms;
    
    public void init()
    {
	
	// get the url parameter from HTML page
	//
	String url = getParameter("url");
	
	// lookup the server remote object with String url
	//
	try {
	    PrivilegeManager.enablePrivilege("UniversalConnect");
	    Registry registry = LocateRegistry.getRegistry("colorado.npac.syr.edu"); 
//	    ms = (MailServer) Naming.lookup(url);
	    ms = (MailServer) registry.lookup("MailServer");
	}
	catch (Exception e) {
	    System.out.println("MailApplet Exception--> " + e);
	    e.printStackTrace();
	}

	//
	// to here
	//
	
	setLayout(null);
	setSize(425,400);
	
	add(fromname);
	fromname.setBounds(84,36,96,28);
	add(toname);
	toname.setBounds(84,72,96,28);
	add(ccname);
	ccname.setBounds(84,108,96,28);
	add(fromadd);
	fromadd.setBounds(192,36,192,28);
	add(toadd);
	toadd.setBounds(192,72,192,28);
	add(ccadd);
	ccadd.setBounds(192,108,192,28);
	add(subj);
	subj.setBounds(84,180,302,28);
	add(textArea1);
	textArea1.setBounds(84,228,302,71);
	button1.setLabel("SEND");
	add(button1);
	button1.setBackground(java.awt.Color.lightGray);
	button1.setBounds(192,312,60,24);
	label1.setText("From");
	label1.setAlignment(java.awt.Label.CENTER);
	add(label1);
	label1.setBounds(25,35,50,30);
	label2.setText("To");
	label2.setAlignment(java.awt.Label.CENTER);
	add(label2);
	label2.setBounds(25,75,50,30);
	label3.setText("CC");
	label3.setAlignment(java.awt.Label.CENTER);
	add(label3);
	label3.setBounds(25,110,50,30);
	label4.setText("Subject");
	label4.setAlignment(java.awt.Label.CENTER);
	add(label4);
	label4.setBounds(24,180,50,30);
	label5.setText("Context");
	label5.setAlignment(java.awt.Label.CENTER);
	add(label5);
	label5.setBounds(24,228,50,30);
	add(attch);
	attch.setBounds(84,144,302,28);
	label6.setText("Attach");
	label6.setAlignment(java.awt.Label.CENTER);
	add(label6);
	label6.setBounds(24,144,50,30);
	add(nameLabel);
	nameLabel.setBounds(84,10,96,20);
	nameLabel.setText("Name");
	nameLabel.setAlignment(java.awt.Label.CENTER);
	add(adrLabel);
	adrLabel.setBounds(192,10,192,20);
	adrLabel.setText("Address");
	adrLabel.setAlignment(java.awt.Label.CENTER);
	
	SymAction lSymAction = new SymAction();
	button1.addActionListener(lSymAction);
    }
    
    java.awt.TextField fromname = new java.awt.TextField();
    java.awt.TextField toname = new java.awt.TextField();
    java.awt.TextField ccname = new java.awt.TextField();
    java.awt.TextField fromadd = new java.awt.TextField();
    java.awt.TextField toadd = new java.awt.TextField();
    java.awt.TextField ccadd = new java.awt.TextField();
    java.awt.TextField subj = new java.awt.TextField();
    java.awt.TextField attch = new java.awt.TextField();
    java.awt.TextArea textArea1 = new java.awt.TextArea();
    java.awt.Button button1 = new java.awt.Button();
    java.awt.Label label1 = new java.awt.Label();
    java.awt.Label label2 = new java.awt.Label();
    java.awt.Label label3 = new java.awt.Label();
    java.awt.Label label4 = new java.awt.Label();
    java.awt.Label label5 = new java.awt.Label();
    java.awt.Label label6 = new java.awt.Label();
    java.awt.Label nameLabel = new java.awt.Label();
    java.awt.Label adrLabel = new java.awt.Label();
    
    // very necessary parameters are
    // sender, senderAdr, toN (toName), toA (toAdress) -- for sure
    // fileName, fileType, bytes -- if you have attachment file
    // subject, context -- if you have
    // vector and hashtable -- if you have Cc 
    //
    private String fileName; 
    private String fType = "image/gif";
    private String sender, senderAdr, subject, context;
    private String toN,toA,ccN,ccA;
    private Hashtable hsh1, hsh2;
    private Vector v1, v2;
    private int n=0;
    private byte bytes[];

    class SymAction implements java.awt.event.ActionListener
    {
	public void actionPerformed(java.awt.event.ActionEvent event)
	{
	    Object object = event.getSource();
	    if (object == button1)
		button1_ActionPerformed(event);
	}
    }
    

    // method which call remote object
    //
    public void sendMail(String sender, String senderAdr, Vector toRcpts, Vector ccRcpts, String subject, String context) 
	throws java.rmi.RemoteException {
	try {
	    PrivilegeManager.enablePrivilege("UniversalConnect");
	    ms.sendEMail(sender, senderAdr, toRcpts, ccRcpts, subject, context); 
	}
	catch (Exception e) {
	    System.out.println("MailClient Exception--> " + e);
	    e.printStackTrace();
	}
    }
    
    // method which call remote object
    // (override function for attachment file)
    //
    public void sendMailAtt(String sender, String senderAdr, Vector toRcpts, Vector ccRcpts, String subject, String context, byte[] bytes, String fType, String fName) 
	throws java.rmi.RemoteException{
	try {
	    PrivilegeManager.enablePrivilege("UniversalConnect");
	    ms.sendEMail(sender, senderAdr, toRcpts, ccRcpts, subject, context, bytes, fType, fName); 
	}
	catch (Exception e) {
	    System.out.println("MailClient Exception--> " + e);
	    e.printStackTrace();
	}
    }
    
    void button1_ActionPerformed(java.awt.event.ActionEvent event)
    {
	// to do: code goes here.
	sender = fromname.getText();
	senderAdr = fromadd.getText();
	toN = toname.getText();
	toA = toadd.getText();
	ccN = ccname.getText();
	ccA = ccadd.getText();
	fileName = attch.getText();
	
	hsh1 = new Hashtable();
	hsh1.put("toadr", toA);
	hsh1.put("toname", toN);
	v1 = new Vector();
	v1.addElement(hsh1);
	
	hsh2 = new Hashtable();
	hsh2.put("ccadr", ccA);
	hsh2.put("ccname", ccN);
	v2 = new Vector();
	v2.addElement(hsh2);
	
	subject = subj.getText();
	context = textArea1.getText();
	
	// for test, I read a file from local drive
	// and read it to byte[]
	// 
	if(fileName.length()!=0) {
	    try {
		PrivilegeManager.enablePrivilege("UniversalFileRead");
	    	File f              = new File(fileName);
		FileInputStream fin = new FileInputStream(fileName);
	    
		// read the entire file into the byte array
		bytes           = new byte[(int)(f.length())];
		n               = fin.read(bytes);
	    }	
	    catch(Exception e) {
		e.printStackTrace();
	    }
	}
	
	// if you have attachment file
	//
	if(n>0) {
	    try {
		sendMailAtt(sender, senderAdr, v1, v2, subject, context, bytes, fType, fileName); 
	    }
	    catch(Exception e) {}
	}

	// without attachment file
	//
	else {
	    try {
		sendMail(sender, senderAdr, v1, v2, subject, context); 
	    }
	    catch(Exception e) {}
	}
    }
}










