import java.io.*;
import java.lang.*;
import java.util.*;

public class MajordomoList {
	
	public static String read(String sourceFile) throws IOException {

		BufferedReader br = new BufferedReader( new FileReader(sourceFile));

		try {
			File f = new File(sourceFile);
			if (!f.exists()) abort(" Source File not exist ");

			String s = br.readLine();
			StringTokenizer t = new StringTokenizer(s,";");

			String name = t.nextToken();
			String email = t.nextToken();		

			System.out.println(name);
			System.out.println(email);

			return email;
			
		}
		finally {
			if(br!=null) try { br.close(); }
				      catch (IOException e) { ; }
		}
	}

	public static void subscribe(String destFile, String email) throws IOException {

		TangoMail tm = new TangoMail("postoffice.npac.syr.edu");

		PrintWriter pw = null;
		FileWriter fw = null;
		BufferedReader br = new BufferedReader( new FileReader(destFile));
		int ok = 1;
		int ef = 1;
		boolean checkEmail;
		
		try {
			File f = new File(destFile);
			if (!f.exists()) abort(" Destination File not exist ");

			while(ef!=0) {

				String s = br.readLine();
				System.out.println(s);
				if(s!=null) {
				    ok = s.compareTo(email);
				}
				else { ef = 0; }
			}

			checkEmail = checkList(email);

			if((ok!=0)&&(checkEmail)) {
				try {
	    				Hashtable toHsh = new Hashtable();
					Vector toVector = new Vector();
			
					toHsh.put("toadr","soh03@top.cis.syr.edu");
					toHsh.put("toname","Majordomo");
					toVector.addElement(toHsh);
	
					System.out.println(tm + "\n");	
					tm.setFrom("  ",email);
					tm.addTo(toVector);
					tm.setSubject(" ");
					tm.setContext("subscribe
tango \nend");
					tm.sendMail();
				}

				catch(MailException e) {
                			System.out.println(" error : " + e.getMessage());
                		}  		

				fw = new FileWriter(destFile,true);
				pw = new PrintWriter(fw);
				pw.write("\n" + email,0,(email.length()+1));
			}
		}
		finally {
			if(pw!=null)  { pw.close();}
		}
	}
/*
	public static void unsubscribe(String _email) throws IOException {
		PrintWriter pw = null;
		FileWriter fw = null;

		File f = new File("unsubsList.txt");
		if (!f.exists()) abort(" UnsubsList.txt File not exist ");

		BufferedReader br = new BufferedReader( new FileReader("subsList.txt"));
		int ef = 1;
		try {
			while(ef!=0) {

				String s = br.readLine();
				System.out.println(s);
				if(s!=null) {
				    if((s.compareTo(_email))!=0) {
					fw = new FileWriter(destFile,true);
					pw = new PrintWriter(fw);
					pw.write("\n" + email,0,(email.length()+1));
				    }
				}
				else { ef = 0; }
			}

		}
		finally {
			if(pw!=null)  { pw.close();}
		}
	}
*/
	private static boolean checkList(String email) throws IOException {

		PrintWriter pw = null;
		FileWriter fw = null;

		File f = new File("unsubsList.txt");
		if (!f.exists()) abort(" UnsubsList.txt File not exist ");

		BufferedReader br = new BufferedReader( new FileReader("unsubsList.txt"));
		int ok = 1;
		int ef = 1;
		boolean checkEmail = true;

		try {
			while(ef!=0) {

				String s = br.readLine();
				System.out.println(s);
				if(s!=null) {
				    ok = s.compareTo(email);
				}
				else { ef = 0; }
			}

			if(ok==0) checkEmail = false;
			return checkEmail; 
		}
		finally {
			if(br!=null)  { br.close();}
		}
	}		

	private static void abort(String msg) throws IOException {
		throw new IOException(msg);
	}	
/*
	public static void main(String[] args) {

		MajordomoList m;
		String name;
		String email;

		try { email = read(args[0]) ;	
		      subscribe("subsList.txt" , email);
		 }
		catch (IOException e ) { 
			System.err.println(e.getMessage()); 
		} 

	}
*/
}









