/*
 *  FILE : TangoMail.java
 *  AUHTHOR : Sangyoon Oh
 *            soh@napc.syr.edu
 *
 */


import java.util.*;
import java.net.*;
import java.io.*;
import netscape.security.PrivilegeManager;

public class TangoMail {

    // text
    StringBuffer sText = new StringBuffer();
     
    // socket & others
    Socket s = null;
    PrintWriter pout;
    DataInputStream pin;
     
    // initiate 
    private void initVar() {
            
            toRecipients.put("toname","unknown");
            toRecipients.put("toadr","root@localhost"); 
            ccRecipients.put("ccname","unknown");
            ccRecipients.put("ccadr","root@localhost");
            
            toVector.addElement(toRecipients);
            ccVector.addElement(ccRecipients);
    }
    
    // ctor -- specific host  
    public TangoMail(String host) {
            smtpHost = host;
            initVar();              		
    }
  
    // ctor -- local host   
    public TangoMail() {
            initVar();
    }
    
   
    // setfrom  
    public void setFrom (String realName, String address) {
            fromName = realName ;
            fromAdr = address;
    }

    // setDebug
    public void setDebug (boolean how) {
            doDebug = how ;
    }
    
    // get toVector 
    public void addTo (Vector toRcpts) {
            toVector = toRcpts;            
    
    /*        for( i = 0 ; i < toVector.size(); i++) { 
                toRecipients = (Hashtable) toVector.elementAt(i);
                toAdr.addElement((String) toRecipients.get("toadr"));   
                toName.addElement((String) toRecipients.get("toname"));
            } */         
    }

    // get ccVector 
    public void addCc (Vector ccRcpts) { 
            ccVector = ccRcpts;
    /*        for( i = 0 ; i < ccVector.size(); i++) { 
                ccRecipients = (Hashtable) ccVector.elementAt(i);
                ccAdr.addElement((String) ccRecipients.get("ccadr"));   
                ccName.addElement((String) ccRecipients.get("ccname"));
            } */
    }

    // context
    public void setContext (String text) {
            sText.append(text + "\n");
    }
     
    // setSubject 
    public void setSubject( String subject ) {
            sSubject = subject ;
    }

     
    // sendMail       
    public void sendMail() throws MailException  {

        try {
            int i;
            
            try {  
                PrivilegeManager.enablePrivilege("UniversalConnect");
                s = new Socket(smtpHost,25);
            }
            catch (Exception e) {
                System.out.println("Exception " +e);
            }

            pout = new PrintWriter(s.getOutputStream(),true);
            pin = new DataInputStream(s.getInputStream());
            checkResponse(220);
              
            // SMTP
            sendOut("HELO " + authName ,250);  
            sendOut("MAIL FROM: <" + fromAdr + ">", 250);
             
            // target adressees
            for( i = 0 ; i < toVector.size(); i++) { 
                toRecipients = (Hashtable) toVector.elementAt(i);
                toAdr  = (String) toRecipients.get("toadr");   
                sendOut("RCPT TO: <" + toAdr + ">", 250);
            }
            
            String sCcAdr = (String)((Hashtable) ccVector.elementAt(0)).get("ccname");
            
            if  (sCcAdr.compareTo("unknown")!= 0 ) {
                for ( i = 0; i < ccVector.size() ; i++) { //cc
                    ccRecipients = (Hashtable) ccVector.elementAt(i);
                    ccAdr  = (String) ccRecipients.get("ccadr");  
                    sendOut("RCPT TO: <" + ccAdr + ">", 250);
	            }
            }
                        
            // Data
            sendOut("DATA", 354);
            if (doDebug == true) { 
	                System.out.println("<--- SMTPmail Debug : Sending DATA Part --->");
            }    
              
            // std Fields     
            pout.println("DATE: " + new Date(System.currentTimeMillis()));
            pout.println("From: " + standardField(fromName, fromAdr)); // from
            pout.println("Sender: " + standardField(fromName, fromAdr)); // Sender
            
            // To
            for ( i = 0; i < toVector.size() ; i++) { //to
                toRecipients = (Hashtable) toVector.elementAt(i);
                toName  = (String) toRecipients.get("toname");  
                toAdr  = (String) toRecipients.get("toadr");  
	            pout.println("To: " + standardField(toName, toAdr));
            }
            
            // Cc            
            if  (sCcAdr.compareTo("unknown")!=0 ) { 
                 for ( i = 0; i < ccVector.size() ; i++) { //cc
                    ccRecipients = (Hashtable) ccVector.elementAt(i);
                    ccName  = (String) ccRecipients.get("ccname");  
                    ccAdr  = (String) ccRecipients.get("ccadr");  
	                pout.println("Cc: " + standardField(ccName, ccAdr));	  	
                }
            }
            
            // Reply-To
            if  ( fromName.compareTo("unknown") == 0 )  { 
            }
            else{
                    pout.println("Reply-To: " + standardField(fromName, fromAdr));
	        }          
	        
	        // Subject
            pout.println("Subject: " + sSubject);
             
            // Context 
            if ( sText.length() > 0 ) {
	                pout.println(sText);
            }
            pout.println("");
                  
            // done
            pout.println(".");     
            checkResponse(250);
        } 
         
        catch (IOException e) {
            if ( doDebug == true) {
	            System.out.println("<--- SMTPmail Debug : Error " + e.getMessage() + " throw exception." );
            }   
            throw (new MailException("IOException collected: " + e.getMessage()));
        }
        
        
        try {
            sendOut("QUIT", 221);
            s.close();
        } catch (IOException e1) {  // do nothing
        }        
        
        if ( doDebug == true) {
            System.out.println("<--- SMTPmail Debug : done --->");
        }   
    }
    

    // building standard field for SMTP protocol
    private String standardField( String cText, String address) {    
            return (cText + " <" + address + "> ");
    }
      
      
    // send SMTP Protocol
    private void sendOut ( String msg, int respvalue ) throws MailException {
      
        // read and write channel are global
        pout.println(msg);	
        if (doVerify == true) {
            if (doDebug == true) { 
	            System.out.println("<--- SMTPmail Debug : Sent \n" + msg);    
            }
            checkResponse( respvalue );
        }
    }    
    
    private StringBuffer readLine ( DataInputStream fin ) throws IOException {    
            
            // read one line get File in Stream
            StringBuffer line = new StringBuffer(""); 
            char b;   
            
            while (fin.available() > 0) {
                    b = (char) fin.read();
                    if ( b == '\n' ) {
	                    // one line read
	                    break;
                    }
                    line.append(b);
            }
            return (line);
    }
      
    //   
    private void checkResponse (int respvalue) throws MailException {
                // first, lets wait few ms to let the smtp daemon react
                String response = "";
                int counter = 0;
                while ( response.length() == 0 ) {
                        try { Thread.sleep(200);
                        } 
                        catch ( InterruptedException e1) {  // do nothing
                        }
                        
                        try {
	                        response = new String(readLine(pin));
                        } catch ( IOException e ) {
	                            throw (new MailException("IOException while reading from smtpd : " + e.getMessage()));
                        }
                        
                        counter += 1;
                        if (counter > timeOut) {
	                        // stop it. theres somthing wrong
	                        throw (new MailException("SMTPmail : Timeout while waiting for smtpd response."));	
                        }
                }
                
                if (doDebug == true) { 
                        System.out.println("<--- SMTPmail Debug : Response \n" + response );
                }
                
                // check return value
                int retval = 0;
                try {
                        retval =   ((int)  Integer.parseInt( response.substring(0,3)) );
                } 
                catch (Exception e) {
                        retval = 0;
                }
                
                if ( retval == respvalue ) {
                        if (doDebug == true) { 
	                        System.out.println("<--- SMTPmail Debug : Response Ok (" + retval + ")---> ");
                        }
                } 
                else {
                        if (doDebug == true) { 
	                        System.out.println("<--- SMTPmail Debug : Response NOT Ok (Should be " + 
			                response + " but is " + retval + 
			                "Troughd exception." );
                        }
                        throw (new MailException("Wrong smtpd response: Should be " + response + ", is " + retval ));
                }
    }
    
        // global vars
    // string
    private String smtpHost = "localhost" ;
    private String fromName = "unknown";
    private String fromAdr = "unknown@localhost";
    private String toName = "unknown";
    private String toAdr = "unknown@localhost";
    private String ccName = "unknown";
    private String ccAdr = "unknown@localhost";   
    private String sSubject;
    private String authName = "Tango_Mail";

    // vector
    private Vector toVector = new Vector();
    private Vector ccVector = new Vector();
//    private Vector ccName = new Vector();
//    private Vector ccAdr = new Vector();
    
    // hashtable
    private Hashtable toRecipients = new Hashtable();
    private Hashtable ccRecipients = new Hashtable();

        // debug and verify
    private boolean doDebug = false;
    private static boolean doVerify = true;
    private static int timeOut = 20;           //is time times 200 millies  
}

